'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AggregateMetaType = exports.AggregateMeta = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _types = require('./types');

var _tcomb = require('tcomb');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MaybeDateType = (0, _tcomb.maybe)(_tcomb.Date);

var AggregateMeta = exports.AggregateMeta = function () {
  /**
   * @param {String} id
   * @param {Number} version
   * @param {Date} createdAt
   * @param {Date|undefined} updatedAt
   * @param {Date|undefined} deletedAt
   */
  function AggregateMeta(id, version) {
    var createdAt = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Date();
    var updatedAt = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
    var deletedAt = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;

    _classCallCheck(this, AggregateMeta);

    (0, _types.AggregateIdType)(id, ['AggregateMeta', 'id:AggregateId']);
    (0, _types.AggregateVersionType)(version, ['AggregateMeta', 'version:AggregateVersion']);
    (0, _tcomb.Date)(createdAt, ['AggregateMeta', 'createdAt:Date']);
    MaybeDateType(updatedAt, ['AggregateMeta', 'updatedAt:?Date']);
    MaybeDateType(deletedAt, ['AggregateMeta', 'deletedAt:?Date']);
    this._id = id;
    this._version = version;
    this._createdAt = createdAt;
    this._updatedAt = updatedAt;
    this._deletedAt = deletedAt;
  }

  /**
   * @returns {String}
   */


  _createClass(AggregateMeta, [{
    key: 'updated',


    /**
     * Returns an instance of this with updated version and the updatedAt timestamp set
     *
     * @param {Date} updatedAt
     * @returns {AggregateMeta}
     */
    value: function updated() {
      var updatedAt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Date();

      (0, _tcomb.Date)(updatedAt);
      return new AggregateMeta(this.id, this.version + 1, this.createdAt, updatedAt);
    }

    /**
     * Returns an instance of this with updated version and the deletedAt timestamp set
     *
     * @param {Date} deletedAt
     * @returns {AggregateMeta}
     */

  }, {
    key: 'deleted',
    value: function deleted() {
      var deletedAt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Date();

      (0, _tcomb.Date)(deletedAt);
      return new AggregateMeta(this.id, this.version + 1, this.createdAt, this.updatedAt, deletedAt);
    }

    /**
     * Returns true if x is of type AggregateMeta
     *
     * @param {object} x
     * @returns {boolean}
     */

  }, {
    key: 'id',
    get: function get() {
      return this._id;
    }

    /**
     * @returns {Number}
     */

  }, {
    key: 'version',
    get: function get() {
      return this._version;
    }

    /**
     * @returns {Date}
     */

  }, {
    key: 'createdAt',
    get: function get() {
      return this._createdAt;
    }

    /**
     * @returns {Date|undefined}
     */

  }, {
    key: 'updatedAt',
    get: function get() {
      return this._updatedAt;
    }

    /**
     * @returns {Date|undefined}
     */

  }, {
    key: 'deletedAt',
    get: function get() {
      return this._deletedAt;
    }

    /**
     * Returns if the aggregate is deleted
     *
     * @returns {Boolean}
     */

  }, {
    key: 'isDeleted',
    get: function get() {
      return this.deletedAt !== undefined;
    }

    /**
     * Returns the timestamp when the aggregate was modified the last time, which is the latest value of
     * createdAt, updatedAt or deletedAt
     *
     * @returns {Date}
     */

  }, {
    key: 'modifiedAt',
    get: function get() {
      if (this.deletedAt) {
        return this.deletedAt;
      }
      if (this.updatedAt) {
        return this.updatedAt;
      }
      return this.createdAt;
    }
  }], [{
    key: 'is',
    value: function is(x) {
      return x instanceof AggregateMeta || x && x.constructor && x.constructor.name === AggregateMeta.name && 'id' in x && 'version' in x && 'data' in x && 'createdAt' in x && 'updatedAt' in x && 'deletedAt' in x;
    }
  }]);

  return AggregateMeta;
}();

var AggregateMetaType = exports.AggregateMetaType = (0, _tcomb.irreducible)('AggregateMetaType', AggregateMeta.is);