'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MaybeImmutableAggregateRootType = exports.ImmutableAggregateRootType = exports.ImmutableAggregateRoot = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tcomb = require('tcomb');

var _modelEvent = require('./model-event');

var _rheactorErrors = require('@resourcefulhumans/rheactor-errors');

var _aggregateMeta = require('./aggregate-meta');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Base class for aggregates
 */
var ImmutableAggregateRoot = exports.ImmutableAggregateRoot = function () {
  /**
   * @param {AggregateMeta} meta
   */
  function ImmutableAggregateRoot(meta) {
    _classCallCheck(this, ImmutableAggregateRoot);

    (0, _aggregateMeta.AggregateMetaType)(meta, ['ImmutableAggregateRoot', 'meta:AggregateMeta']);
    this._meta = meta;
  }

  /**
   * @returns {AggregateMeta}
   */


  _createClass(ImmutableAggregateRoot, [{
    key: 'meta',
    get: function get() {
      return this._meta;
    }

    /**
     * Applies the event to the aggregate.
     * Return a new, updated aggregate.
     *
     * @param {ModelEvent} event
     * @param {ImmutableAggregateRoot|undefined} aggregate May be undefined for the first event (usually the create event)
     * @returns {ImmutableAggregateRoot}
     */

  }], [{
    key: 'applyEvent',
    value: function applyEvent(event, aggregate) {
      (0, _modelEvent.ModelEventType)(event, ['ImmutableAggregateRoot', 'applyEvent()', 'event:ModelEvent']);
      MaybeImmutableAggregateRootType(aggregate, ['ImmutableAggregateRoot', 'applyEvent()', 'aggregate:?ImmutableAggregateRoot']);
      throw new _rheactorErrors.UnhandledDomainEventError(event.name + ' because applyEvent is not implemented.');
    }

    /**
     * Returns true if x is of type AggregateRoot
     *
     * @param {object} x
     * @returns {boolean}
     */

  }, {
    key: 'is',
    value: function is(x) {
      return x instanceof ImmutableAggregateRoot || x && x.constructor && x.constructor.name === ImmutableAggregateRoot.name && 'meta' in x && 'applyEvent' in x;
    }
  }]);

  return ImmutableAggregateRoot;
}();

var ImmutableAggregateRootType = exports.ImmutableAggregateRootType = (0, _tcomb.irreducible)('ImmutableAggregateRootType', ImmutableAggregateRoot.is);
var MaybeImmutableAggregateRootType = exports.MaybeImmutableAggregateRootType = (0, _tcomb.maybe)(ImmutableAggregateRootType);