'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModelEventTypeList = exports.ModelEventType = exports.ModelEvent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tcomb = require('tcomb');

var _types = require('./types');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ModelEvent = exports.ModelEvent = function () {
  /**
   * If a model is modified the modifying method should return and instance of this
   * event that represents the change
   *
   * @param {String} aggregateId The id that identifies a specific aggregate
   * @param {String} name The name of the event
   * @param {Object} data The data associated with the event
   * @param {Date} createdAt The time of the creation of the event
   * @param {String} createdBy Information about the author of the event
   */
  function ModelEvent(aggregateId, name) {
    var data = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var createdAt = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : new Date();
    var createdBy = arguments[4];

    _classCallCheck(this, ModelEvent);

    (0, _types.AggregateIdType)(aggregateId);
    (0, _tcomb.String)(name);
    (0, _tcomb.Object)(data);
    (0, _tcomb.Date)(createdAt);
    (0, _types.MaybeStringType)(createdBy);
    Object.defineProperty(this, 'aggregateId', { value: aggregateId, enumerable: true });
    Object.defineProperty(this, 'name', { value: name, enumerable: true });
    Object.defineProperty(this, 'data', { value: data, enumerable: true });
    Object.defineProperty(this, 'createdAt', { value: createdAt, enumerable: true });
    Object.defineProperty(this, 'createdBy', { value: createdBy, enumerable: true });
  }

  /**
   * Returns true if x is of type ModelEvent
   *
   * @param {object} x
   * @returns {boolean}
   */


  _createClass(ModelEvent, null, [{
    key: 'is',
    value: function is(x) {
      return x instanceof ModelEvent || x && x.constructor && x.constructor.name === ModelEvent.name && 'aggregateId' in x && 'name' in x && 'data' in x && 'createdAt' in x && 'createdBy' in x;
    }
  }]);

  return ModelEvent;
}();

var ModelEventType = exports.ModelEventType = (0, _tcomb.irreducible)('ModelEventType', ModelEvent.is);
var ModelEventTypeList = exports.ModelEventTypeList = (0, _tcomb.list)(ModelEventType);