'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SnapshotAggregateRepository = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _aggregateRepository = require('./aggregate-repository');

var _types = require('./types');

var _tcomb = require('tcomb');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SnapshotAggregateRepository = exports.SnapshotAggregateRepository = function () {
  function SnapshotAggregateRepository(repo) {
    _classCallCheck(this, SnapshotAggregateRepository);

    (0, _aggregateRepository.AggregateRepositoryType)(repo);
    this.repo = repo;
  }

  /**
   * Returns a scope function, which needs to be called with at
   * @param {String} id
   * @return {Function}
   */


  _createClass(SnapshotAggregateRepository, [{
    key: 'getById',
    value: function getById(id) {
      var _this = this;

      (0, _types.AggregateIdType)(id);
      return {
        until: function until(_until) {
          (0, _tcomb.Date)(_until);
          return _this.repo.eventStore.fetch(id).filter(function (event) {
            return event.createdAt <= _until;
          }).then(function (events) {
            return _this.repo.eventsToAggregate(id, events);
          });
        }
      };
    }
  }]);

  return SnapshotAggregateRepository;
}();